/* Collector.c generated by valac 0.44.3, the Vala compiler
 * generated from Collector.vala, do not modify */

/* Collector.vala
 *
 * Copyright (C) 2018  kosmolot (kosmolot17@yandex.com)
 *
 * This file is part of Gpseq.
 *
 * Gpseq is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * Gpseq is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Gpseq.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>

#define GPSEQ_TYPE_COLLECTOR (gpseq_collector_get_type ())
#define GPSEQ_COLLECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_COLLECTOR, GpseqCollector))
#define GPSEQ_IS_COLLECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_COLLECTOR))
#define GPSEQ_COLLECTOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GPSEQ_TYPE_COLLECTOR, GpseqCollectorIface))

typedef struct _GpseqCollector GpseqCollector;
typedef struct _GpseqCollectorIface GpseqCollectorIface;
typedef enum  {
	GPSEQ_COLLECTOR_FEATURES_CONCURRENT = 1 << 0,
	GPSEQ_COLLECTOR_FEATURES_UNORDERED = 1 << 1
} GpseqCollectorFeatures;

#define GPSEQ_TYPE_COLLECTOR_FEATURES (gpseq_collector_features_get_type ())

struct _GpseqCollectorIface {
	GTypeInterface parent_iface;
	gpointer (*create_accumulator) (GpseqCollector* self);
	void (*accumulate) (GpseqCollector* self, gconstpointer g, gconstpointer a);
	gpointer (*combine) (GpseqCollector* self, gconstpointer a, gconstpointer b);
	gpointer (*finish) (GpseqCollector* self, gconstpointer a);
	GpseqCollectorFeatures (*get_features) (GpseqCollector* self);
};

GType gpseq_collector_features_get_type (void) G_GNUC_CONST;
GType gpseq_collector_get_type (void) G_GNUC_CONST;
gpointer gpseq_collector_create_accumulator (GpseqCollector* self);
void gpseq_collector_accumulate (GpseqCollector* self,
                                 gconstpointer g,
                                 gconstpointer a);
gpointer gpseq_collector_combine (GpseqCollector* self,
                                  gconstpointer a,
                                  gconstpointer b);
gpointer gpseq_collector_finish (GpseqCollector* self,
                                 gconstpointer a);
GpseqCollectorFeatures gpseq_collector_get_features (GpseqCollector* self);

/**
 * Creates a new accumulator.
 */
gpointer
gpseq_collector_create_accumulator (GpseqCollector* self)
{
#line 79 "../src/Collector.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 79 "../src/Collector.vala"
	return GPSEQ_COLLECTOR_GET_INTERFACE (self)->create_accumulator (self);
#line 73 "Collector.c"
}

/**
 * Accumulates a element into a accumulator.
 *
 * This method must be //associative//, //non-interfering//, and
 * //stateless//.
 *
 * @param g element
 * @param a accumulator
 */
void
gpseq_collector_accumulate (GpseqCollector* self,
                            gconstpointer g,
                            gconstpointer a)
{
#line 89 "../src/Collector.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/Collector.vala"
	GPSEQ_COLLECTOR_GET_INTERFACE (self)->accumulate (self, g, a);
#line 94 "Collector.c"
}

/**
 * Combines two accumulators into one.
 *
 * This method must be //associative//, //non-interfering//, and
 * //stateless//.
 *
 * @return combined accumulator.
 */
gpointer
gpseq_collector_combine (GpseqCollector* self,
                         gconstpointer a,
                         gconstpointer b)
{
#line 98 "../src/Collector.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 98 "../src/Collector.vala"
	return GPSEQ_COLLECTOR_GET_INTERFACE (self)->combine (self, a, b);
#line 114 "Collector.c"
}

/**
 * Transforms a accumulator into a final result.
 * @return the final result
 */
gpointer
gpseq_collector_finish (GpseqCollector* self,
                        gconstpointer a)
{
#line 103 "../src/Collector.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 103 "../src/Collector.vala"
	return GPSEQ_COLLECTOR_GET_INTERFACE (self)->finish (self, a);
#line 129 "Collector.c"
}

GpseqCollectorFeatures
gpseq_collector_get_features (GpseqCollector* self)
{
#line 75 "../src/Collector.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 75 "../src/Collector.vala"
	return GPSEQ_COLLECTOR_GET_INTERFACE (self)->get_features (self);
#line 139 "Collector.c"
}

static void
gpseq_collector_default_init (GpseqCollectorIface * iface,
                              gpointer iface_data)
{
	/**
	 * Hints that can be used to optimize collect operations.
	 */
#line 71 "../src/Collector.vala"
	g_object_interface_install_property (iface, g_param_spec_flags ("features", "features", "features", GPSEQ_TYPE_COLLECTOR_FEATURES, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 151 "Collector.c"
}

/**
 * An object for mutable reduction operation that accumulates input
 * elements into a mutable accumulator, and transforms it into a final
 * result.
 *
 * A collector implements four methods: {@link create_accumulator},
 * {@link accumulate}, {@link combine}, and {@link finish}.
 *
 *  i. create_accumulator() - creates a new accumulator, such as {@link Gee.Collection}.
 *  i. accumulate() - incorporates a new element into a accumulator.
 *  i. combine() - combines two accumulators into one.
 *  i. finish() - transforms the accumulator into a final result.
 *
 * The methods must satisfy an //identity// and an //associativity//
 * constraints. The identity constraint means that combining any accumulator
 * with an empty accumulator must produce an equivalent result. i.e. an
 * accumulator //a// must be equivalent to
 * //collector.accumulate(a, collector.create_accumulator())//
 *
 * The associativity constraint means that splitting the computation must
 * produce an equivalent result. i.e.:
 *
 * {{{
 * // the two computations below must be equivalent.
 * // collector: a collector
 * // g0, g1: elements
 *
 * A a0 = collector.create_accumulator();
 * collector.accumulate(g0, a0);
 * collector.accumulate(g1, a0);
 * A r0 = collector.finish(a0);
 *
 * A a1 = collector.create_accumulator();
 * collector.accumulate(g0, a1);
 * A a2 = collector.create_accumulator();
 * collector.accumulate(g1, a2);
 * A r1 = collector.finish( collector.combine(a1, a2) );
 * }}}
 *
 * Collectors also have a property, {@link features}. it provides hints
 * that can be used to optimize the operation.
 *
 * @see Seq.collect
 * @see Seq.collect_ordered
 * @see Collectors
 * @see CollectorFeatures
 */
GType
gpseq_collector_get_type (void)
{
	static volatile gsize gpseq_collector_type_id__volatile = 0;
	if (g_once_init_enter (&gpseq_collector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpseqCollectorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpseq_collector_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gpseq_collector_type_id;
		gpseq_collector_type_id = g_type_register_static (G_TYPE_INTERFACE, "GpseqCollector", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gpseq_collector_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&gpseq_collector_type_id__volatile, gpseq_collector_type_id);
	}
	return gpseq_collector_type_id__volatile;
}

