/* Executor.c generated by valac 0.44.3, the Vala compiler
 * generated from Executor.vala, do not modify */

/* Executor.vala
 *
 * Copyright (C) 2018  kosmolot (kosmolot17@yandex.com)
 *
 * This file is part of Gpseq.
 *
 * Gpseq is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * Gpseq is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Gpseq.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>

#define GPSEQ_TYPE_EXECUTOR (gpseq_executor_get_type ())
#define GPSEQ_EXECUTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_EXECUTOR, GpseqExecutor))
#define GPSEQ_IS_EXECUTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_EXECUTOR))
#define GPSEQ_EXECUTOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GPSEQ_TYPE_EXECUTOR, GpseqExecutorIface))

typedef struct _GpseqExecutor GpseqExecutor;
typedef struct _GpseqExecutorIface GpseqExecutorIface;

#define GPSEQ_TYPE_FORK_JOIN_TASK (gpseq_fork_join_task_get_type ())
#define GPSEQ_FORK_JOIN_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_FORK_JOIN_TASK, GpseqForkJoinTask))
#define GPSEQ_FORK_JOIN_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPSEQ_TYPE_FORK_JOIN_TASK, GpseqForkJoinTaskClass))
#define GPSEQ_IS_FORK_JOIN_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_FORK_JOIN_TASK))
#define GPSEQ_IS_FORK_JOIN_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPSEQ_TYPE_FORK_JOIN_TASK))
#define GPSEQ_FORK_JOIN_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPSEQ_TYPE_FORK_JOIN_TASK, GpseqForkJoinTaskClass))

typedef struct _GpseqForkJoinTask GpseqForkJoinTask;
typedef struct _GpseqForkJoinTaskClass GpseqForkJoinTaskClass;

struct _GpseqExecutorIface {
	GTypeInterface parent_iface;
	void (*submit) (GpseqExecutor* self, GpseqForkJoinTask* task);
	gint (*get_parallels) (GpseqExecutor* self);
};

GType gpseq_fork_join_task_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GpseqForkJoinTask, g_object_unref)
GType gpseq_executor_get_type (void) G_GNUC_CONST;
void gpseq_executor_submit (GpseqExecutor* self,
                            GpseqForkJoinTask* task);
gint gpseq_executor_get_parallels (GpseqExecutor* self);

/**
 * Submits a task.
 * @param task a task to execute
 */
void
gpseq_executor_submit (GpseqExecutor* self,
                       GpseqForkJoinTask* task)
{
#line 31 "../src/Executor.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Executor.vala"
	GPSEQ_EXECUTOR_GET_INTERFACE (self)->submit (self, task);
#line 71 "Executor.c"
}

gint
gpseq_executor_get_parallels (GpseqExecutor* self)
{
#line 36 "../src/Executor.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 36 "../src/Executor.vala"
	return GPSEQ_EXECUTOR_GET_INTERFACE (self)->get_parallels (self);
#line 81 "Executor.c"
}

static void
gpseq_executor_default_init (GpseqExecutorIface * iface,
                             gpointer iface_data)
{
	/**
	 * The (maximal) number of threads.
	 */
#line 26 "../src/Executor.vala"
	g_object_interface_install_property (iface, g_param_spec_int ("parallels", "parallels", "parallels", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 93 "Executor.c"
}

/**
 * An object that executes fork-join tasks. the execution is performed
 * sequentially or in parallel, depending on the executor implementation.
 */
GType
gpseq_executor_get_type (void)
{
	static volatile gsize gpseq_executor_type_id__volatile = 0;
	if (g_once_init_enter (&gpseq_executor_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpseqExecutorIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpseq_executor_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gpseq_executor_type_id;
		gpseq_executor_type_id = g_type_register_static (G_TYPE_INTERFACE, "GpseqExecutor", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gpseq_executor_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&gpseq_executor_type_id__volatile, gpseq_executor_type_id);
	}
	return gpseq_executor_type_id__volatile;
}

