/* QueueBalancer.c generated by valac 0.44.3, the Vala compiler
 * generated from QueueBalancer.vala, do not modify */

/* QueueBalancer.vala
 *
 * Copyright (C) 2018  kosmolot (kosmolot17@yandex.com)
 *
 * This file is part of Gpseq.
 *
 * Gpseq is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * Gpseq is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Gpseq.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>

#define GPSEQ_TYPE_QUEUE_BALANCER (gpseq_queue_balancer_get_type ())
#define GPSEQ_QUEUE_BALANCER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_QUEUE_BALANCER, GpseqQueueBalancer))
#define GPSEQ_IS_QUEUE_BALANCER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_QUEUE_BALANCER))
#define GPSEQ_QUEUE_BALANCER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GPSEQ_TYPE_QUEUE_BALANCER, GpseqQueueBalancerIface))

typedef struct _GpseqQueueBalancer GpseqQueueBalancer;
typedef struct _GpseqQueueBalancerIface GpseqQueueBalancerIface;

#define GPSEQ_TYPE_FORK_JOIN_THREAD (gpseq_fork_join_thread_get_type ())
#define GPSEQ_FORK_JOIN_THREAD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_FORK_JOIN_THREAD, GpseqForkJoinThread))
#define GPSEQ_FORK_JOIN_THREAD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPSEQ_TYPE_FORK_JOIN_THREAD, GpseqForkJoinThreadClass))
#define GPSEQ_IS_FORK_JOIN_THREAD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_FORK_JOIN_THREAD))
#define GPSEQ_IS_FORK_JOIN_THREAD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPSEQ_TYPE_FORK_JOIN_THREAD))
#define GPSEQ_FORK_JOIN_THREAD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPSEQ_TYPE_FORK_JOIN_THREAD, GpseqForkJoinThreadClass))

typedef struct _GpseqForkJoinThread GpseqForkJoinThread;
typedef struct _GpseqForkJoinThreadClass GpseqForkJoinThreadClass;

struct _GpseqQueueBalancerIface {
	GTypeInterface parent_iface;
	void (*tick) (GpseqQueueBalancer* self, GpseqForkJoinThread* thread, gboolean join);
	void (*computed) (GpseqQueueBalancer* self, GpseqForkJoinThread* thread, gboolean join);
	void (*no_tasks) (GpseqQueueBalancer* self, GpseqForkJoinThread* thread, gboolean join);
	void (*scan) (GpseqQueueBalancer* self, GpseqForkJoinThread* thread, gboolean join);
};

GType gpseq_fork_join_thread_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GpseqForkJoinThread, g_object_unref)
GType gpseq_queue_balancer_get_type (void) G_GNUC_CONST;
void gpseq_queue_balancer_tick (GpseqQueueBalancer* self,
                                GpseqForkJoinThread* thread,
                                gboolean join);
void gpseq_queue_balancer_computed (GpseqQueueBalancer* self,
                                    GpseqForkJoinThread* thread,
                                    gboolean join);
void gpseq_queue_balancer_no_tasks (GpseqQueueBalancer* self,
                                    GpseqForkJoinThread* thread,
                                    gboolean join);
void gpseq_queue_balancer_scan (GpseqQueueBalancer* self,
                                GpseqForkJoinThread* thread,
                                gboolean join);

/**
 * Will be called at every loop start.
 * @param thread the fork-join thread
 * @param join whether or not current loop is joining loop of a task
 */
void
gpseq_queue_balancer_tick (GpseqQueueBalancer* self,
                           GpseqForkJoinThread* thread,
                           gboolean join)
{
#line 46 "../src/QueueBalancer.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/QueueBalancer.vala"
	GPSEQ_QUEUE_BALANCER_GET_INTERFACE (self)->tick (self, thread, join);
#line 84 "QueueBalancer.c"
}

/**
 * Will be called after the thread obtained a task and has computed it.
 * @param thread the fork-join thread
 * @param join whether or not current loop is joining loop of a task
 */
void
gpseq_queue_balancer_computed (GpseqQueueBalancer* self,
                               GpseqForkJoinThread* thread,
                               gboolean join)
{
#line 53 "../src/QueueBalancer.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/QueueBalancer.vala"
	GPSEQ_QUEUE_BALANCER_GET_INTERFACE (self)->computed (self, thread, join);
#line 101 "QueueBalancer.c"
}

/**
 * Will be called after the thread failed to obtain a task.
 * @param thread the fork-join thread
 * @param join whether or not current loop is joining loop of a task
 */
void
gpseq_queue_balancer_no_tasks (GpseqQueueBalancer* self,
                               GpseqForkJoinThread* thread,
                               gboolean join)
{
#line 60 "../src/QueueBalancer.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/QueueBalancer.vala"
	GPSEQ_QUEUE_BALANCER_GET_INTERFACE (self)->no_tasks (self, thread, join);
#line 118 "QueueBalancer.c"
}

/**
 * Finds and takes tasks from other threads' work queue and the
 * submission queue.
 *
 * This method must take at least one task, if possible -- at least one
 * task exists in other threads' work queue or the submission queue.
 *
 * @param thread the fork-join thread
 * @param join whether or not current loop is joining loop of a task
 */
void
gpseq_queue_balancer_scan (GpseqQueueBalancer* self,
                           GpseqForkJoinThread* thread,
                           gboolean join)
{
#line 72 "../src/QueueBalancer.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/QueueBalancer.vala"
	GPSEQ_QUEUE_BALANCER_GET_INTERFACE (self)->scan (self, thread, join);
#line 140 "QueueBalancer.c"
}

static void
gpseq_queue_balancer_default_init (GpseqQueueBalancerIface * iface,
                                   gpointer iface_data)
{
}

/**
 * An object that performs load balancing of work queues.
 *
 * A {@link ForkJoinThread} have its own {@link QueueBalancer}. so, the
 * balancers can declare and use member variables to store data per thread.
 *
 * All methods are called in the owner {@link ForkJoinThread} thread.
 *
 * loop flow:
 *  i. {@link tick} : every loop start
 *  i. try obtaining a task in the queue of the current thread
 *    * if obtained, the thread computes it. and => {@link computed}
 *      * at this step, if join == true, the loop ends
 *    * if not obtained (no tasks exist in the queue)
 *      i. {@link no_tasks}
 *      i. at this step, if join == false, the thread may be deactivated by pool
 *      i. {@link scan}
 */
GType
gpseq_queue_balancer_get_type (void)
{
	static volatile gsize gpseq_queue_balancer_type_id__volatile = 0;
	if (g_once_init_enter (&gpseq_queue_balancer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpseqQueueBalancerIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpseq_queue_balancer_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gpseq_queue_balancer_type_id;
		gpseq_queue_balancer_type_id = g_type_register_static (G_TYPE_INTERFACE, "GpseqQueueBalancer", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gpseq_queue_balancer_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&gpseq_queue_balancer_type_id__volatile, gpseq_queue_balancer_type_id);
	}
	return gpseq_queue_balancer_type_id__volatile;
}

