/* Supplier.c generated by valac 0.44.3, the Vala compiler
 * generated from Supplier.vala, do not modify */

/* Supplier.vala
 *
 * Copyright (C) 2018  kosmolot (kosmolot17@yandex.com)
 *
 * This file is part of Gpseq.
 *
 * Gpseq is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or (at your
 * option) any later version.
 *
 * Gpseq is distributed in the hope that it will be useful, but WITHOUT ANY
 * WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with Gpseq.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <glib.h>

#define GPSEQ_TYPE_SUPPLIER (gpseq_supplier_get_type ())
#define GPSEQ_SUPPLIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_SUPPLIER, GpseqSupplier))
#define GPSEQ_IS_SUPPLIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_SUPPLIER))
#define GPSEQ_SUPPLIER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), GPSEQ_TYPE_SUPPLIER, GpseqSupplierIface))

typedef struct _GpseqSupplier GpseqSupplier;
typedef struct _GpseqSupplierIface GpseqSupplierIface;
typedef gpointer (*GpseqSupplyFunc) (gpointer user_data);

#define GPSEQ_TYPE_DEFAULT_SUPPLIER (gpseq_default_supplier_get_type ())
#define GPSEQ_DEFAULT_SUPPLIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GPSEQ_TYPE_DEFAULT_SUPPLIER, GpseqDefaultSupplier))
#define GPSEQ_DEFAULT_SUPPLIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GPSEQ_TYPE_DEFAULT_SUPPLIER, GpseqDefaultSupplierClass))
#define GPSEQ_IS_DEFAULT_SUPPLIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GPSEQ_TYPE_DEFAULT_SUPPLIER))
#define GPSEQ_IS_DEFAULT_SUPPLIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GPSEQ_TYPE_DEFAULT_SUPPLIER))
#define GPSEQ_DEFAULT_SUPPLIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GPSEQ_TYPE_DEFAULT_SUPPLIER, GpseqDefaultSupplierClass))

typedef struct _GpseqDefaultSupplier GpseqDefaultSupplier;
typedef struct _GpseqDefaultSupplierClass GpseqDefaultSupplierClass;

struct _GpseqSupplierIface {
	GTypeInterface parent_iface;
	gpointer (*supply) (GpseqSupplier* self);
};

GType gpseq_supplier_get_type (void) G_GNUC_CONST;
GpseqSupplier* gpseq_supplier_from_func (GType t_type,
                                         GBoxedCopyFunc t_dup_func,
                                         GDestroyNotify t_destroy_func,
                                         GpseqSupplyFunc func,
                                         gpointer func_target,
                                         GDestroyNotify func_target_destroy_notify);
GpseqDefaultSupplier* gpseq_default_supplier_new (GType t_type,
                                                  GBoxedCopyFunc t_dup_func,
                                                  GDestroyNotify t_destroy_func,
                                                  GpseqSupplyFunc func,
                                                  gpointer func_target,
                                                  GDestroyNotify func_target_destroy_notify);
GpseqDefaultSupplier* gpseq_default_supplier_construct (GType object_type,
                                                        GType t_type,
                                                        GBoxedCopyFunc t_dup_func,
                                                        GDestroyNotify t_destroy_func,
                                                        GpseqSupplyFunc func,
                                                        gpointer func_target,
                                                        GDestroyNotify func_target_destroy_notify);
GType gpseq_default_supplier_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GpseqDefaultSupplier, g_object_unref)
gpointer gpseq_supplier_supply (GpseqSupplier* self);

/**
 * Creates a new supplier from the given supply function.
 * @param func a supply function
 * @return a new supplier from the given supply function
 */
GpseqSupplier*
gpseq_supplier_from_func (GType t_type,
                          GBoxedCopyFunc t_dup_func,
                          GDestroyNotify t_destroy_func,
                          GpseqSupplyFunc func,
                          gpointer func_target,
                          GDestroyNotify func_target_destroy_notify)
{
	GpseqSupplier* result = NULL;
	GpseqSupplyFunc _tmp0_;
	gpointer _tmp0__target;
	GDestroyNotify _tmp0__target_destroy_notify;
	GpseqDefaultSupplier* _tmp1_;
#line 32 "../src/Supplier.vala"
	_tmp0_ = func;
#line 32 "../src/Supplier.vala"
	_tmp0__target = func_target;
#line 32 "../src/Supplier.vala"
	_tmp0__target_destroy_notify = func_target_destroy_notify;
#line 32 "../src/Supplier.vala"
	func = NULL;
#line 32 "../src/Supplier.vala"
	func_target = NULL;
#line 32 "../src/Supplier.vala"
	func_target_destroy_notify = NULL;
#line 32 "../src/Supplier.vala"
	_tmp1_ = gpseq_default_supplier_new (t_type, (GBoxedCopyFunc) t_dup_func, (GDestroyNotify) t_destroy_func, _tmp0_, _tmp0__target, _tmp0__target_destroy_notify);
#line 32 "../src/Supplier.vala"
	result = (GpseqSupplier*) _tmp1_;
#line 32 "../src/Supplier.vala"
	(func_target_destroy_notify == NULL) ? NULL : (func_target_destroy_notify (func_target), NULL);
#line 32 "../src/Supplier.vala"
	func = NULL;
#line 32 "../src/Supplier.vala"
	func_target = NULL;
#line 32 "../src/Supplier.vala"
	func_target_destroy_notify = NULL;
#line 32 "../src/Supplier.vala"
	return result;
#line 120 "Supplier.c"
}

/**
 * Supplies a result.
 * @return a result
 */
gpointer
gpseq_supplier_supply (GpseqSupplier* self)
{
#line 39 "../src/Supplier.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 39 "../src/Supplier.vala"
	return GPSEQ_SUPPLIER_GET_INTERFACE (self)->supply (self);
#line 134 "Supplier.c"
}

static void
gpseq_supplier_default_init (GpseqSupplierIface * iface,
                             gpointer iface_data)
{
}

/**
 * An object that supplies a result.
 */
GType
gpseq_supplier_get_type (void)
{
	static volatile gsize gpseq_supplier_type_id__volatile = 0;
	if (g_once_init_enter (&gpseq_supplier_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GpseqSupplierIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gpseq_supplier_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType gpseq_supplier_type_id;
		gpseq_supplier_type_id = g_type_register_static (G_TYPE_INTERFACE, "GpseqSupplier", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (gpseq_supplier_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&gpseq_supplier_type_id__volatile, gpseq_supplier_type_id);
	}
	return gpseq_supplier_type_id__volatile;
}

